AuraMastery 				= {}
AuraMastery.name 			= "AuraMastery"
AuraMastery.version 		= "0.01a"
AuraMastery.author		= "Letho"

AMBUFFER 		= {};

-- locals
local WM = WINDOW_MANAGER;

local profileDefaults 		= {
	updateSpeed				= 100,
	activeProfile			= 1,
	profiles					= {
		["profileNames"] 	= {
			[1] 				= "default",
		},
		["profileData"] 	= {
			[1] = {
				['auraData'] = {};
			},
		}
	}	
};
AuraMastery.activeEffects	= {};
AuraMastery.trackedEvents 	= {
	['EVENT_EFFECT_CHANGED'] = {
		['abilityIds'] = {};
	}
};
AuraMastery.loadedAuras		= {};
--AuraMastery.auraAbilityIds = {};
AuraMastery.menuHidden 		= true;

-- initialization
function AuraMastery.OnAddOnLoaded(event, addonName)
	if addonName ~= AuraMastery.name then return end	
	EVENT_MANAGER:UnregisterForEvent(AuraMastery.name, EVENT_ADD_ON_LOADED);
	AuraMastery:Initialize();
end

function AuraMastery:Initialize()
	self:GetAbilityIdsByName();
	self:LoadProfileData();
	self:InitializeControls();

	EVENT_MANAGER:RegisterForEvent(AuraMastery.name, EVENT_EFFECT_CHANGED, AuraMastery.OnEffectEvent);
	EVENT_MANAGER:RegisterForUpdate(AuraMastery.name, AuraMastery.savedVariables.updateSpeed, AuraMastery.updateHandler);
end

function AuraMastery:LoadProfileData()
	self.savedVariables = ZO_SavedVars:New("AuraMasterySavedVariables", 1, nil, profileDefaults);
	self.svars = self.savedVariables.profiles.profileData[self.savedVariables.activeProfile];
end

local function slashHandler(userInput)
	local parsedUserInput = {string.match(userInput,"^(%S*)%s*(.-)$")}
	local command = {}
	local n = #parsedUserInput;
	for i=1, n do
		if (parsedUserInput[i] ~= nil and parsedUserInput[i] ~= "") then
			command[i] = string.lower(parsedUserInput[i]);
		end
	end

	if ("unlock" == command[1]) then
		for k, v in pairs(AuraMastery.aura) do
			AuraMastery:UnloadAuras();
			v:SetHidden(false);
			v:SetMouseEnabled(true);
			v:SetMovable(true);
			SetGameCameraUIMode(true);
		end
		d("Auras unlocked.");
	end
	
	if ("lock" == command[1]) then
		for k, v in pairs(AuraMastery.aura) do
			AuraMastery:LoadAura(k);
			v:SetHidden(true);
			v:SetMouseEnabled(false);
			v:SetMovable(false);
			SetGameCameraUIMode(false);
		end
		d("Auras locked.");
	end

	if ("menu" == command[1]) then
		local container = WM:GetControlByName("AuraMasteryMenuContainer");
		--self:CreateMenu();
		if (container:IsHidden()) then
			container:SetHidden(false);
		else
			container:SetHidden(true);
		end
	end

	if ("?" == string.sub(AuraMastery:trim(command[1]),1,1)) then
		local abilityName = string.sub(AuraMastery:trim(command[1]), 2);
		AuraMastery:GetAbilityIds(abilityName);
	end
end
SLASH_COMMANDS["/am"] = slashHandler;

EVENT_MANAGER:RegisterForEvent(AuraMastery.name, EVENT_ADD_ON_LOADED, AuraMastery.OnAddOnLoaded);